pro ip, list, _extra = extra

  readcol, list, file, format='a', comment='#'
;  file = 'jupiter-31800_int.fits'

;  start = [dc, amp, sx, sy, xo, yo, angle]
  name = ['Offset', 'Amplitude', 'SigmaX', 'SigmaY', 'X0', 'Y0', 'Angle']
  pi = replicate({fixed:0, limited:[0,0], limits:[0,0], parname:' '},$
                 n_elements(name))
  pi.fixed=[0,0,0,0,0,0,0]
  for i = 0, n_elements(name)-1 do begin
      pi[i].parname = name[i]
  endfor
  pi.limited = [ $
                 [0,0], $       ; Offset
                 [1,0], $       ; Amplitude
                 [1,0], $       ; sigma-X
                 [1,0], $       ; sigma-Y
                 [0,0], $       ; X-center
                 [0,0], $       ; Y-center
                 [0,0]  ]       ; Angle
  pi.limits = [ $
                [0,0], $        ; Offset
                [0,0], $        ; Amplitude
                [0,0], $        ; sigma-X
                [0,0], $        ; sigma-Y
                [0,0], $        ; X-center
                [0,0], $        ; Y-center
                [0,0]  ]        ; Angle
  ui = fltarr(n_elements(file))
  uierr = ui
  qi = ui
  qierr = ui
  elev = ui
  eleverr = elev
  tau = elev
  pa = elev

  for f = 0, n_elements(file)-1 do begin
      fits_read, file[f], imi, hdr, exten_no=0
      elev[f] = sxpar(hdr, 'TEL_ELEV', /silent)
      pa[f] = sxpar(hdr, 'PARA_ANG', /silent)
      fits_read, file[f], ierr, hdr, exten_no=1+1
      fits_read, file[f], imq, hdr, exten_no=2+1
      fits_read, file[f], qerr, hdr, exten_no=3+1
      fits_read, file[f], imu, hdr, exten_no=4+1
      fits_read, file[f], uerr, hdr, exten_no=5+1
      fits_read, file[f], mask, hdr, exten_no=6+1
      fits_read, file[f], tmp, hdr, exten_no=7+1
      tau[f] = sxpar(hdr, 'TAU225GH', /silent)
      
      maxi = max(imi[where(finite(imi) eq 1)])
      good = where(mask eq 0 and imi gt 0.5*maxi)
      rq = imq[good] / imi[good]
      rqerr = sqrt(qerr[good]^2 + rq^2 * ierr[good]^2) / imi[good]
      ru = imu[good] / imi[good]
      ruerr = sqrt(uerr[good]^2 + ru^2 * ierr[good]^2) / imi[good]

      uierr[f] = total(1./ruerr^2)
;      print, uerr
      ui[f] = total(ru/ruerr^2)
      ui[f] /= uierr[f]
      uierr[f] = 1. / sqrt(uierr[f])
      qierr[f] = total(1./rqerr^2)
      qi[f] = total(rq/rqerr^2)
      qi[f] /= qierr[f]
      qierr[f] = 1. / sqrt(qierr[f])

;      ; FIT
      weights = mask* 0.
      weights[where(mask eq 0)] = 1.
      weights[where(mask gt 0)] = 0.
      weights[where(imi lt 0.5*maxi)] = 0.;
;  start = [dc, amp, sx, sy, xo, yo, angle]
;      start = [0., max(imi), 2.0, 2.0, 5.0, 5.0, 0.0]
;      yfit = mpfit2dpeak(imi, params, $
;                         estimates = start, $
;                         weights = weights, $
;                         chisq = chisq, dof=dof, perror = perror, /tilt)
;help, yfit, imi, params, ierr, start, chisq, dof, perror
;      print, 'chisq = ', chisq, dof, chisq/dof
;      print, 'params = ', params
;;      print, 'perrors = ', perror
;
;      plot, imi[*,6], psym=4
;      oplot, yfit[*,6]
;
;      plotimage, bytscl(imi), /preserve, title = file[f]
;      wait, 1
;      surface, imi, /lego
;      wait,1
  endfor
 for f = 0, n_elements(file)-1 do begin
      print, file[f], elev[f], tau[f]
  endfor
;print, qi
;stopmaxi = max(imi[where(finite(imi) eq 1)])

; Do linear regression using Ax = b
  b = [qi, ui]
  berr = [qierr, uierr]
  b = transpose(b)
  berr = transpose(berr)
  a1 = [cos(2.*elev*!dtor), -sin(2.*elev*!dtor)]
  a2 = [-sin(2.*elev*!dtor), -cos(2.*elev*!dtor)] 
  a3 = [replicate(1.0 , n_elements(file)), $
        replicate(0.0, n_elements(file))]
  a4 = [replicate(0.0, n_elements(file)), $
        replicate(1.0, n_elements(file))]
  a5 = [cos(2.*(elev+pa)*!dtor), -sin(2.*(elev+pa)*!dtor)]
  a6 = [-sin(2.*(elev+pa)*!dtor), -cos(2.*(elev+pa)*!dtor)]
;  a5 = [replicate(0.0 , n_elements(file)), $
;        replicate(0.0, n_elements(file))]
;  a6 = [replicate(0.0, n_elements(file)), $
;        replicate(0.0, n_elements(file))]
  a1 /= berr
  a2 /= berr
  a3 /= berr
  a4 /= berr
  a5 /= berr
  a6 /= berr
  b /= berr
  a = [transpose(a1), transpose(a2), transpose(a3), transpose(a4), $
       transpose(a5), transpose(a6)]
  ata = transpose(a) ## a
help, a, b
  atb = transpose(a) ## b
  cov = invert(ata)
  print, 'relative covariance matrix = '
  print, cov / max(cov)
  params = cov ## atb
  yfit = (a ## params)
help, yfit, berr
  chisq = total( (b - yfit)^2 ) 
  print, 'unreduced chisq = ', chisq
  chisq /= (n_elements(b) - n_elements(params))
  print, 'reduced chisq = ', chisq
  perror = sqrt(diag_matrix(cov))
  print, 'errors : ', perror
  perror *= sqrt(chisq)
  print, 'errors scaled so reduced chisq = 1 : ', perror
  smel = findgen(101)/100 * 90
  qi -= params[4] * cos(2.*(elev+pa)*!dtor) - $
        params[5] * sin(2.*(elev+pa)*!dtor)
  ui -= -1 * params[4] * sin(2.*(elev+pa)*!dtor) - $
        params[5] * cos(2.*(elev+pa)*!dtor)
  qtot = params[0] * cos(2.*smel*!dtor) - params[1] * sin(2.*smel*!dtor) + $
         params[2] * 1.0 + params[3] * 0.0
;  qtot_e1 = params[0] * cos(2.*smel*!dtor) - params[1] * sin(2.*smel*!dtor) + $
;    (params[2]+perror[2]) * 1.0 + params[3] * 0.0
  utot = -params[0] * sin(2.*smel*!dtor) - params[1] * cos(2.*smel*!dtor) + $
    params[2] * 0.0 + (params[3]+perror[3]) * 1.0

  erase
  multiplot, [0,1,2,0,0]
  ploterror, elev, qi, eleverr, qierr, psym=4, $
    ;xtit = 'Telescope Elevation (degrees)', $
    ytit = 'Instrumental q', $
    xra=[0,90], /xsty
;  oplot, elev, yfit[0:n_elements(elev)-1],/psym
  oplot, smel, qtot
  oplot, [0,90], [1,1]*params[2],linesty=1
;  oplot, smel, qtot_e1, linesty=2
;  for f = 0, n_elements(file)-1 do begin
;;      label = strmid(file[f], 9, 4)
;      label = strtrim(f)
;      xyouts, elev[f], qi[f], label,size=2,align=1
;  endfor
;  help, elev, qi, files

  multiplot
  ploterror, elev, ui, eleverr, uierr, psym=4, $
    xtit = 'Telescope Elevation (degrees)', $
    ytit = 'Instrumental u', $
    xra=[0,90], /xsty
  oplot, [0,90], [1,1]*params[3],linesty=1
;  for f = 0, n_elements(file)-1 do begin
;      label = strmid(file[f], 9, 4)
;      xyouts, elev[f], ui[f], label
;  endfor
  oplot, smel, utot
  ;help, a, ata, cov, params, a3, a4, a1, a2

;help, transpose(a), b, atb
;print, b
;print, cov

print, 'q_t(%) = ', params[0]*100, ' +/-', perror[0]*100
print, 'u_t(%) = ', params[1]*100, ' +/-', perror[1]*100
print, 'q_i(%) = ', params[2]*100, ' +/-', perror[2]*100
print, 'u_i(%) = ', params[3]*100, ' +/-', perror[3]*100
print, 'q_s(%) = ', params[4]*100, ' +/-', perror[4]*100
print, 'u_s(%) = ', params[5]*100, ' +/-', perror[5]*100
stokes2polar, params[0], perror[0], params[1], perror[1], $
              pt, pterr, phit, phiterr
stokes2polar, params[2], perror[2], params[3], perror[3], $
              pi, pierr, phii, phiierr
stokes2polar, params[4], perror[4], params[5], perror[5], $
              ps, pserr, phis, phiserr
print, 'Amp_t (%) = ', 100.*pt, ' +/- ', pterr*100
print, 'phase_t (deg.) = ', phit, ' +/- ', phiterr
print, 'Amp_i (%) = ', 100.*pi, ' +/- ', pierr*100
print, 'phase_i (deg.) = ',  phii, ' +/- ', phiierr
print, 'Amp_s (%) = ', 100.*ps, ' +/- ', pserr*100
print, 'phase_s (deg.) = ',  phis, ' +/- ', phiserr

  params = [2.90e-3, 2.43e-5, .0041, .0012]
;  qtot = params[0] * cos(2.*smel*!dtor) - params[1] * sin(2.*smel*!dtor) + $
;    params[2] * 1.0 + params[3] * 0.0
;  utot = -params[0] * sin(2.*smel*!dtor) - params[1] * cos(2.*smel*!dtor) + $
;    params[2] * 0.0 + params[3] * 1.0
;  wset,0
;  oplot, smel, qtot, linesty=2
;  wset,1
;  oplot, smel, utot, linesty=2
print, 'old fit'
print, 'q_t = ', params[0]
print, 'u_t = ', params[1]
print, 'q_i = ', params[2]
print, 'u_i = ', params[3]
print, 'Amp_t (%) = ', sqrt(params[0]^2 + params[1]^2) * 100.
print, 'phase_t (deg.) = ', 0.5*atan(params[1], params[0]) * !radeg
print, 'Amp_i (%) = ', sqrt(params[2]^2 + params[3]^2) * 100.
print, 'phase_i (deg.) = ', 0.5*atan(params[3], params[2]) * !radeg

multiplot,/reset

end
